<!DOCTYPE html>
<html lang="fr" dir="ltr">
<head>
  <meta charset="utf-8">
  <title>Les 4 saisons</title>
  <link rel="stylesheet" href="css/style.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js" integrity="sha512-894YE6QWD5I59HgZOGReFYm4dnWc1Qt5NtvYSaNcOP+u1T9qYdvdihz0PPSiiqn/+/3e7Jo4EaG7TubfWGUrMQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/1.4.0/p5.min.js" integrity="sha512-N4kV7GkNv7QR7RX9YF/olywyIgIwNvfEe2nZtfyj73HdjCUkAfOBDbcuJ/cTaN04JKRnw1YG1wnUyNKMsNgg3g==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/howler/2.2.3/howler.min.js" integrity="sha512-6+YN/9o9BWrk6wSfGxQGpt3EUK6XeHi6yeHV+TYD2GR0Sj/cggRpXr1BrAQf0as6XslxomMUxXp2vIl+fv0QRA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
</head>
<body>
  <div class="container">
    <button id="spring" class="toggled">
      <img src="./icons/spring.svg" alt="spring">
    </button>
    <button id="summer">
      <img src="./icons/summer.svg" alt="summer">
    </button>
    <button id="autumn">
      <img src="./icons/autumn.svg" alt="autumn">
    </button>
    <button id="winter">
      <img src="./icons/winter.svg" alt="winter">
    </button>
  </div>
</body>
</html>
<script src="modules/Spring.js"></script>
<script src="modules/Summer.js"></script>
<script src="modules/Autumn.js"></script>
<script src="modules/Winter.js"></script>
<script type="module">
    import { socket } from './modules/socketIO.js'
    window.socket = socket
    window.fakerType = 'touch'
</script>
<script>
  let width = window.innerWidth, height = window.innerHeight
  let DEFAULT_MULT = 0.015, DEFAULT_NOISE = 500, DEFAULT_DEG = 360, DEFAULT_BG = 30
  let points = [], vector, x, y
  let spring, summer, autumn, winter
  let actualSeason = document.querySelector('.toggled').id

  const btns = document.querySelectorAll("button")
  for(let btn of btns){
    btn.addEventListener('click', () => { change(btn) })
  }

  //=== SOUND

  let bgSound = new Howl({
    src: ['/sounds/4saisons.mp3', '/sounds/violonxbasse.mp3'],
    autoplay: false,
    loop: true
  })

  let bass = new Howl({
    src: ['/sounds/random/ligne_de_basse_.mp3'],
    autoplay: true,
    loop: true,
    volume: 0
  })

  let id1 = bgSound.play()
  bgSound.fade(0, 1, 2000, id1)

  //===
  function setup() {
    createCanvas(width, height)
    background(DEFAULT_BG)
    angleMode(DEFAULT_DEG)
    noiseDetail(DEFAULT_NOISE)

    window.socket.emit(window.fakerType)
    window.socket.on(window.fakerType, (data) => {
      console.log('socket', data)

      if (data.nb_peoples > 1){
        bass.fade(0, 1, 2000)
      } else {
        bass.fade(1, 0, 2000)
      }

      for (var i = 0; i < data.nb_peoples; i++) {
        lx = data.peoples[i].left_hand.x * windowWidth
        ly = data.peoples[i].left_hand.y * windowHeight
        rx = data.peoples[i].right_hand.x * windowWidth
        ry = data.peoples[i].right_hand.y * windowHeight

        if (inBtn('spring', rx, ry)){ // spring
          change('spring')
        } else if(inBtn('summer', rx, ry)){ // summer
          change('summer')
        } else if(inBtn('autumn', rx, ry)){ // autumn
          change('autumn')
        } else if(inBtn('winter', rx, ry)){ // winter
          change('winter')
        }

        x = lx
        y = ly

        //draw(lx, ly)
        //draw(rx, ry)
      }
    })
  }

  function draw() {
    console.log(x, y)
    noStroke()

    if (x && y) {
      switcher(x, y)
    } else if (mouseIsPressed) {
      switcher(mouseX, mouseY)
    }
  }

  function switcher(x, y){
    //console.log(x, y)
    switch (actualSeason){
      case 'spring':
        vector = createVector(x, y)
        spring = new Spring(vector)
        spring.display()
        break

      case 'summer':
        vector = createVector(x, y)
        summer = new Summer(vector)
        summer.display()
        break

      case 'autumn':
        vector = createVector(x, y)
        autumn = new Autumn(vector)
        autumn.display()
        break

      case 'winter':
        vector = createVector(x, y)
        winter = new Winter(vector)
        winter.display()
        break
    }
  }

  function cleanup(bg, noise, angle){
    points = []
    //clear()
    //background(bg)
    //angleMode(angle)
    //noiseDetail(noise)
  }

  function inBtn(id, x, y){
    let btn = document.getElementById(id).getBoundingClientRect()
    console.log('in', (btn.top <= x &&  x <= btn.bottom) && (btn.left <= y && y <= btn.right))
    return (btn.top <= x &&  x <= btn.bottom) && (btn.left <= y && y <= btn.right)
  }

  function change(btn){
    if ( !(btn.classList.contains('toggled')) ){
      document.querySelector(".toggled").classList.toggle('toggled')
      btn.classList.toggle('toggled')
      actualSeason = btn.id
    }

    cleanup(DEFAULT_BG, DEFAULT_NOISE, DEFAULT_DEG)
  }
</script>
